\chapter*{Abstract}
\label{chapter:abstract}
Nowadays, deploying and executing applications in the cloud is a reality.
The cloud can not exist without virtualization.
This concept consists of slicing physical machines into several sub-machines, isolated from one another, known as virtual machines.

Recently, containers emerged as a viable alternative to virtual machines.
Containers are lighter than virtual machines and bring the same isolation and security guarantees.
Nonetheless, the isolation they offer is maybe too important.
Indeed, existing mechanisms enforce memory isolation by ensuring that no container starves the others; however, they do not adapt to changes in workload.
Thus, it is impossible to consolidate memory, \textit{i.e.} to reclaim memory unused by some containers to make a better use of it.

To answer this problem and ensure both isolation and consolidation, we introduce MemOpLight.
This mechanism adapts to workload changes thanks to application feedback.
Each container tells the kernel whether it has good or bad performance to guide memory reclaim.
Memory is first reclaimed from containers with good performance in the hope that the others can improve their own performance.
The idea is to find a balance where all containers have satisfying performance.

MemOpLight increases container satisfactions by 13\% compared to existing mechanisms.